Index: trunk/LMDZ.GENERIC/libf/phystd/convadj.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/convadj.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/convadj.F	(revision 787)
@@ -5,4 +5,6 @@
      &                   pduadj,pdvadj,pdhadj,
      &                   pdqadj)
+
+      USE tracer_h
 
       implicit none
@@ -31,5 +33,4 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
 
 
@@ -54,11 +55,11 @@
 
       INTEGER ig,i,l,l1,l2,jj
-      INTEGER jcnt, jadrs(ngridmx)
+      INTEGER jcnt, jadrs(ngrid)
 
       REAL sig(nlayermx+1),sdsig(nlayermx),dsig(nlayermx)
-      REAL zu(ngridmx,nlayermx),zv(ngridmx,nlayermx)
-      REAL zh(ngridmx,nlayermx)
-      REAL zu2(ngridmx,nlayermx),zv2(ngridmx,nlayermx)
-      REAL zh2(ngridmx,nlayermx), zhc(ngridmx,nlayermx)
+      REAL zu(ngrid,nlayermx),zv(ngrid,nlayermx)
+      REAL zh(ngrid,nlayermx)
+      REAL zu2(ngrid,nlayermx),zv2(ngrid,nlayermx)
+      REAL zh2(ngrid,nlayermx), zhc(ngrid,nlayermx)
       REAL zhm,zsm,zdsm,zum,zvm,zalpha,zhmc
 
@@ -66,6 +67,6 @@
       INTEGER iq,ico2
       save ico2
-      REAL zq(ngridmx,nlayermx,nqmx), zq2(ngridmx,nlayermx,nqmx)
-      REAL zqm(nqmx),zqco2m
+      REAL zq(ngrid,nlayermx,nq), zq2(ngrid,nlayermx,nq)
+      REAL zqm(nq),zqco2m
       real m_co2, m_noco2, A , B
       save A, B
@@ -73,5 +74,5 @@
       real mtot1, mtot2 , mm1, mm2
        integer l1ref, l2ref
-      LOGICAL vtest(ngridmx),down,firstcall
+      LOGICAL vtest(ngrid),down,firstcall
       save firstcall
       data firstcall/.true./
@@ -87,14 +88,8 @@
 
       IF (firstcall) THEN 
-        IF(ngrid.NE.ngridmx) THEN
-           PRINT*
-           PRINT*,'STOP in convadj'
-           PRINT*,'ngrid    =',ngrid
-           PRINT*,'ngridmx  =',ngridmx
-        ENDIF
         ico2=0
         if (tracer) then
 !     Prepare Special treatment if one of the tracers is CO2 gas
-           do iq=1,nqmx
+           do iq=1,nq
              if (noms(iq).eq."co2") then
                 print*,'dont go there'
@@ -401,5 +396,5 @@
         do iq=1, nq
           do  l=1,nlay
-            do ig=1, ngrid
+            DO ig=1,ngrid
               pdqadj(ig,l,iq)=(zq2(ig,l,iq)-zq(ig,l,iq))/ptimestep 
             end do 
Index: trunk/LMDZ.GENERIC/libf/phystd/datareadnc.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/datareadnc.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/datareadnc.F	(revision 787)
@@ -85,6 +85,6 @@
       INTEGER    i,j,k
 
-      INTEGER klatdat,ngridmxgdat
-      PARAMETER (klatdat=180,ngridmxgdat=360)
+      INTEGER klatdat,ngridmixgdat
+      PARAMETER (klatdat=180,ngridmixgdat=360)
 
 c    on passe une grille en rlonu rlatv et im+1 jm a interp_horiz)
@@ -245,7 +245,7 @@
       do j=1,jmdp1
           do i=1,imd
-              zdataS(i+imdp1*(j-1)) = zdata(i+ngridmxgdat*(j-1))
+              zdataS(i+imdp1*(j-1)) = zdata(i+ngridmixgdat*(j-1))
           enddo
-          zdataS(imdp1+imdp1*(j-1)) = zdata(1+ngridmxgdat*(j-1))
+          zdataS(imdp1+imdp1*(j-1)) = zdata(1+ngridmixgdat*(j-1))
       enddo
 
Index: trunk/LMDZ.GENERIC/libf/phystd/dimphys.h
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/dimphys.h	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/dimphys.h	(revision 787)
@@ -12,2 +12,9 @@
       !integer, parameter :: nsoilmx = 13 ! for z1=0.03 cm, depth = 104.8 m => earth case
 !-----------------------------------------------------------------------
+
+      common/dimphys/cursor
+      integer cursor  !! this is the position of point 1 on the globe
+                      !! it is 1 obviously for sequential runs
+                      !! but might differ for paraller runs
+                      !! it is used in phyetat0 mostly
+
Index: trunk/LMDZ.GENERIC/libf/phystd/evap.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/evap.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/evap.F	(revision 787)
@@ -1,6 +1,7 @@
-      subroutine evap(dtime,pt, pq, pdq, pdt,  
+      subroutine evap(ngrid,nq,dtime,pt, pq, pdq, pdt,  
      $     dqevap,dtevap, qevap, tevap) 
         
       use watercommon_h 
+      USE tracer_h
 
       implicit none
@@ -8,5 +9,4 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "tracer.h"
 #include "comcstfi.h"
 
@@ -24,16 +24,18 @@
 !==================================================================
 
+      INTEGER ngrid,nq
+
 ! Arguments:
-      REAL pt(ngridmx,nlayermx) 
-      REAL pq(ngridmx,nlayermx,nqmx) 
-      REAL pdt(ngridmx,nlayermx) 
-      REAL pdq(ngridmx,nlayermx,nqmx) 
-      REAL dqevap(ngridmx,nlayermx)
-      REAL dtevap(ngridmx,nlayermx)
-      REAL qevap(ngridmx,nlayermx,nqmx)
+      REAL pt(ngrid,nlayermx) 
+      REAL pq(ngrid,nlayermx,nq) 
+      REAL pdt(ngrid,nlayermx) 
+      REAL pdq(ngrid,nlayermx,nq) 
+      REAL dqevap(ngrid,nlayermx)
+      REAL dtevap(ngrid,nlayermx)
+      REAL qevap(ngrid,nlayermx,nq)
       REAL dtime
  
 ! Local:
-      REAL tevap(ngridmx,nlayermx) 
+      REAL tevap(ngrid,nlayermx) 
       REAL zlvdcp
       REAL zlsdcp
@@ -46,5 +48,5 @@
 
       DO l=1,nlayermx
-        DO ig=1,ngridmx
+        DO ig=1,ngrid
          qevap(ig,l,igcm_h2o_vap)=pq(ig,l,igcm_h2o_vap)	
      s          	          +pdq(ig,l,igcm_h2o_vap)*dtime
@@ -56,5 +58,5 @@
 
       DO l = 1, nlayermx  
-      	DO ig = 1, ngridmx
+      	DO ig = 1, ngrid
          zlvdcp=RLVTT/RCPD!/(1.0+RVTMP2*qevap(ig,l,igcm_h2o_vap))
          zlsdcp=RLSTT/RCPD!/(1.0+RVTMP2*qevap(ig,l,igcm_h2o_vap))
Index: trunk/LMDZ.GENERIC/libf/phystd/forceWCfn.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/forceWCfn.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/forceWCfn.F	(revision 787)
@@ -1,3 +1,5 @@
-      subroutine forceWCfn(pplev,pt,dq,dqs)
+      subroutine forceWCfn(ngrid,nq,pplev,pt,dq,dqs)
+
+      USE tracer_h
 
       implicit none
@@ -19,18 +21,19 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "tracer.h"
+
+      INTEGER ngrid,nq
 
       real masse, Wtot, Wdiff
 
-      real pplev(ngridmx,nlayermx+1)
-      real pt(ngridmx)
+      real pplev(ngrid,nlayermx+1)
+      real pt(ngrid)
 
-      real dqs(ngridmx,nqmx) 
-      real dq(ngridmx,nlayermx,nqmx)
+      real dqs(ngrid,nq) 
+      real dq(ngrid,nlayermx,nq)
 
       integer iq, ig, ilay
 
-      do iq=1,nqmx 
-        do ig=1,ngridmx
+      do iq=1,nq 
+        do ig=1,ngrid
            Wtot = 0.0
            do ilay=1,nlayermx
Index: trunk/LMDZ.GENERIC/libf/phystd/hydrol.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/hydrol.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/hydrol.F90	(revision 787)
@@ -1,7 +1,11 @@
-subroutine hydrol(ptimestep,rnat,tsurf,          &
+subroutine hydrol(ngrid,nq,ptimestep,rnat,tsurf,          &
      qsurf,dqsurf,dqs_hyd,pcapcal,                &
      albedo0,albedo,mu0,pdtsurf,pdtsurf_hyd,hice)
 
   use watercommon_h, only: T_h2O_ice_liq, RLFTT, rhowater, mx_eau_sol
+  USE surfdat_h
+  use comdiurn_h
+  USE comgeomfi_h
+  USE tracer_h
 
   implicit none
@@ -36,9 +40,6 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
-#include "fisice.h"
-#include "comgeomfi.h"
-#include "comdiurn.h"
-#include "surfdat.h"
+
+      integer ngrid,nq
 
 !     Inputs
@@ -60,16 +61,15 @@
 !     Arguments
 !     ---------
-      integer rnat(ngridmx) ! I changed this to integer (RW)
-      real runoff(ngridmx)
-      save runoff
+      integer rnat(ngrid) ! I changed this to integer (RW)
+      real,dimension(:),allocatable,save :: runoff
       real totalrunoff, tsea, oceanarea
       save oceanarea
 
       real ptimestep
-      real mu0(ngridmx)
-      real qsurf(ngridmx,nqmx), tsurf(ngridmx)
-      real dqsurf(ngridmx,nqmx), pdtsurf(ngridmx)
-      real hice(ngridmx)
-      real albedo0(ngridmx), albedo(ngridmx)
+      real mu0(ngrid)
+      real qsurf(ngrid,nq), tsurf(ngrid)
+      real dqsurf(ngrid,nq), pdtsurf(ngrid)
+      real hice(ngrid)
+      real albedo0(ngrid), albedo(ngrid)
 
       real oceanarea2
@@ -77,6 +77,6 @@
 !     Output
 !     ------
-      real dqs_hyd(ngridmx,nqmx)
-      real pdtsurf_hyd(ngridmx)
+      real dqs_hyd(ngrid,nq)
+      real pdtsurf_hyd(ngrid)
 
 !     Local
@@ -85,9 +85,9 @@
       integer ig,iq, icap ! wld like to remove icap
       real fsnoi, subli, fauxo
-      real twater(ngridmx)
-      real pcapcal(ngridmx)
-      real hicebis(ngridmx)
-      real zqsurf(ngridmx,nqmx)
-      real ztsurf(ngridmx)
+      real twater(ngrid)
+      real pcapcal(ngrid)
+      real hicebis(ngrid)
+      real zqsurf(ngrid,nq)
+      real ztsurf(ngrid)
 
       integer ivap, iliq, iice
@@ -104,4 +104,6 @@
 
       if(firstcall)then
+
+         ALLOCATE(runoff(ngrid))
 
          ivap=igcm_h2o_vap
@@ -126,5 +128,5 @@
 !     Total ocean surface area
          oceanarea=0.
-         do ig=1,ngridmx
+         do ig=1,ngrid
             if(rnat(ig).eq.0)then
                oceanarea=oceanarea+area(ig)
@@ -150,19 +152,19 @@
 !     ------------------------------------------
 
-      do ig=1,ngridmx
+      do ig=1,ngrid
          ztsurf(ig) = tsurf(ig) + ptimestep*pdtsurf(ig)
          pdtsurf_hyd(ig)=0.0
-         do iq=1,nqmx
+         do iq=1,nq
             zqsurf(ig,iq) = qsurf(ig,iq) + ptimestep*dqsurf(ig,iq)
          enddo    
       enddo
  
-      do ig=1,ngridmx
-         do iq=1,nqmx
+      do ig=1,ngrid
+         do iq=1,nq
             dqs_hyd(ig,iq) = 0.0
          enddo
       enddo
 
-      do ig = 1, ngridmx
+      do ig = 1, ngrid
 
 !     Ocean
@@ -257,5 +259,5 @@
 
                runoff(ig) = max(zqsurf(ig,iliq) - mx_eau_sol, 0.0)
-               if(ngridmx.gt.1)then ! runoff only exists in 3D
+               if(ngrid.gt.1)then ! runoff only exists in 3D
                   if(runoff(ig).ne.0.0)then
                      zqsurf(ig,iliq) = mx_eau_sol
@@ -283,5 +285,5 @@
          endif
 
-      end do ! ig=1,ngridmx
+      end do ! ig=1,ngrid
 
 !     perform crude bulk averaging of temperature in ocean
@@ -290,5 +292,5 @@
 
          oceanarea2=0.       
-         DO ig=1,ngridmx
+         DO ig=1,ngrid
             if((rnat(ig).eq.0).and.(hice(ig).eq.0.))then
                oceanarea2=oceanarea2+area(ig)*pcapcal(ig)
@@ -297,5 +299,5 @@
        
          tsea=0.
-         DO ig=1,ngridmx
+         DO ig=1,ngrid
             if((rnat(ig).eq.0).and.(hice(ig).eq.0.))then       
                tsea=tsea+ztsurf(ig)*area(ig)*pcapcal(ig)/oceanarea2
@@ -303,5 +305,5 @@
          END DO
 
-         DO ig=1,ngridmx
+         DO ig=1,ngrid
             if((rnat(ig).eq.0).and.(hice(ig).eq.0))then
                pdtsurf_hyd(ig) = pdtsurf_hyd(ig) + (tsea-ztsurf(ig))/oceantime
@@ -318,5 +320,5 @@
 
          totalrunoff=0.
-         do ig=1,ngridmx
+         do ig=1,ngrid
             if (rnat(ig).eq.1) then
                totalrunoff = totalrunoff + area(ig)*runoff(ig)
@@ -324,5 +326,5 @@
          enddo
          
-         do ig=1,ngridmx
+         do ig=1,ngrid
             if (rnat(ig).eq.0) then
                zqsurf(ig,iliq) = zqsurf(ig,iliq) + &
@@ -338,5 +340,5 @@
 
          icap=1
-         do ig=1,ngridmx
+         do ig=1,ngrid
             if (qsurf(ig,igcm_co2_ice).gt.0) then
                albedo(ig) = albedice(icap)
@@ -347,10 +349,10 @@
 
 
-      do ig=1,ngridmx
+      do ig=1,ngrid
          dqs_hyd(ig,iliq)=(zqsurf(ig,iliq) - qsurf(ig,iliq))/ptimestep
          dqs_hyd(ig,iice)=(zqsurf(ig,iice) - qsurf(ig,iice))/ptimestep
       enddo
 
-      call writediagfi(ngridmx,'runoff','Runoff amount',' ',2,runoff)
+      call writediagfi(ngrid,'runoff','Runoff amount',' ',2,runoff)
 
       return
Index: trunk/LMDZ.GENERIC/libf/phystd/inifis.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 787)
@@ -6,4 +6,11 @@
       use radinc_h, only : naerkind
       use datafile_mod, only: datadir
+      use comdiurn_h
+
+      !! to be conservative, but why this include here?
+      use surfdat_h
+      use comsaison_h
+
+      USE comgeomfi_h
 
 !=======================================================================
@@ -50,9 +57,5 @@
 #include "planete.h"
 #include "comcstfi.h"
-#include "comsaison.h"
-#include "comdiurn.h"
-#include "comgeomfi.h"
 #include "callkeys.h"
-#include "surfdat.h"
 
 
@@ -61,5 +64,5 @@
  
       INTEGER ngrid,nlayer
-      REAL plat(ngrid),plon(ngrid),parea(ngridmx)
+      REAL plat(ngrid),plon(ngrid),parea(ngrid)
       integer day_ini
       INTEGER ig,ierr
@@ -87,4 +90,6 @@
       avocado = 6.02214179e23   ! added by RW
 
+      cursor = 1 ! added by AS in dimphys. 1 for sequential runs.
+
 ! --------------------------------------------------------
 !     The usual Tests
@@ -95,12 +100,4 @@
          PRINT*,'nlayer     = ',nlayer
          PRINT*,'nlayermx   = ',nlayermx
-         STOP
-      ENDIF
-
-      IF (ngrid.NE.ngridmx) THEN
-         PRINT*,'STOP in inifis'
-         PRINT*,'Probleme de dimensions :'
-         PRINT*,'ngrid     = ',ngrid
-         PRINT*,'ngridmx   = ',ngridmx
          STOP
       ENDIF
@@ -299,5 +296,5 @@
 ! Test of incompatibility:
 ! if kastprof used, we must be in 1D
-         if (kastprof.and.(ngridmx.gt.1)) then
+         if (kastprof.and.(ngrid.gt.1)) then
            print*,'kastprof can only be used in 1D!'
            call abort
@@ -350,5 +347,5 @@
 ! Test of incompatibility:
 ! if testradtimes used, we must be in 1D
-         if (testradtimes.and.(ngridmx.gt.1)) then
+         if (testradtimes.and.(ngrid.gt.1)) then
            print*,'testradtimes can only be used in 1D!'
            call abort
@@ -595,8 +592,19 @@
 !     ------------------------
 
+      ! ALLOCATE ARRAYS IN comgeomfi_h
+      IF (.not. ALLOCATED(lati)) ALLOCATE(lati(ngrid))
+      IF (.not. ALLOCATED(long)) ALLOCATE(long(ngrid))
+      IF (.not. ALLOCATED(area)) ALLOCATE(area(ngrid))
+
       CALL SCOPY(ngrid,plon,1,long,1)
       CALL SCOPY(ngrid,plat,1,lati,1)
       CALL SCOPY(ngrid,parea,1,area,1)
-      totarea=SSUM(ngridmx,area,1)
+      totarea=SSUM(ngrid,area,1)
+
+      !! those are defined in comdiurn_h.F90
+      IF (.not.ALLOCATED(sinlat)) ALLOCATE(sinlat(ngrid))
+      IF (.not.ALLOCATED(coslat)) ALLOCATE(coslat(ngrid))
+      IF (.not.ALLOCATED(sinlon)) ALLOCATE(sinlon(ngrid))
+      IF (.not.ALLOCATED(coslon)) ALLOCATE(coslon(ngrid))
 
       DO ig=1,ngrid
Index: trunk/LMDZ.GENERIC/libf/phystd/initracer.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 787)
@@ -1,5 +1,7 @@
-      SUBROUTINE initracer()
-
-
+      SUBROUTINE initracer(ngrid,nq,nametrac)
+
+      use surfdat_h
+      USE comgeomfi_h
+      USE tracer_h
       IMPLICIT NONE
 c=======================================================================
@@ -13,5 +15,5 @@
 c   Test of dimension :
 c   Initialize COMMON tracer in tracer.h, using tracer names provided
-c   by the dynamics in "advtrac.h"
+c   by the argument nametrac
 c
 c   author: F.Forget
@@ -25,12 +27,9 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
-#include "advtrac.h"
-#include "comgeomfi.h"
-#include "watercap.h"
-#include "fisice.h"
-
-!      real qsurf(ngridmx,nqmx)       ! tracer on surface (e.g.  kg.m-2)
-!      real co2ice(ngridmx)           ! co2 ice mass on surface (e.g.  kg.m-2)
+
+      integer :: ngrid,nq
+
+!      real qsurf(ngrid,nq)       ! tracer on surface (e.g.  kg.m-2)
+!      real co2ice(ngrid)           ! co2 ice mass on surface (e.g.  kg.m-2)
       character(len=20) :: txt ! to store some text
       integer iq,ig,count
@@ -38,11 +37,13 @@
 !      logical :: oldnames ! =.true. if old tracer naming convention (q01,...)
 
+      character*20 nametrac(nq)   ! name of the tracer from dynamics
+
 
 c-----------------------------------------------------------------------
-c  radius(nqmx)      ! aerosol particle radius (m)
-c  rho_q(nqmx)       ! tracer densities (kg.m-3)
-c  qext(nqmx)        ! Single Scat. Extinction coeff at 0.67 um
-c  alpha_lift(nqmx)  ! saltation vertical flux/horiz flux ratio (m-1)
-c  alpha_devil(nqmx) ! lifting coeeficient by dust devil
+c  radius(nq)      ! aerosol particle radius (m)
+c  rho_q(nq)       ! tracer densities (kg.m-3)
+c  qext(nq)        ! Single Scat. Extinction coeff at 0.67 um
+c  alpha_lift(nq)  ! saltation vertical flux/horiz flux ratio (m-1)
+c  alpha_devil(nq) ! lifting coeeficient by dust devil
 c  rho_dust          ! Mars dust density
 c  rho_ice           ! Water ice density
@@ -51,4 +52,19 @@
 c-----------------------------------------------------------------------
 
+       !! we allocate once for all arrays in common in tracer_h.F90
+       !! (supposedly those are not used before call to initracer)
+       ALLOCATE(noms(nq))
+       ALLOCATE(mmol(nq))
+       ALLOCATE(radius(nq))
+       ALLOCATE(rho_q(nq))
+       ALLOCATE(qext(nq))
+       ALLOCATE(alpha_lift(nq))
+       ALLOCATE(alpha_devil(nq))
+       ALLOCATE(qextrhor(nq))
+       ALLOCATE(igcm_dustbin(nq))
+       !! initialization
+       alpha_lift(:)=0.
+       alpha_devil(:)=0.
+
 ! Initialization: get tracer names from the dynamics and check if we are
 !                 using 'old' tracer convention ('q01',q02',...)
@@ -57,6 +73,6 @@
 
 ! copy tracer names from dynamics
-        do iq=1,nqmx
-          noms(iq)=tnom(iq)
+        do iq=1,nq
+          noms(iq)=nametrac(iq)
         enddo
 
@@ -65,5 +81,5 @@
       ! 0. initialize tracer indexes to zero:
       ! NB: igcm_* indexes are commons in 'tracer.h'
-      do iq=1,nqmx
+      do iq=1,nq
         igcm_dustbin(iq)=0
       enddo
@@ -97,5 +113,5 @@
       count=0
 !      if (dustbin.gt.0) then
-!        do iq=1,nqmx
+!        do iq=1,nq
 !          txt=" "
 !          write(txt,'(a4,i2.2)')'dust',count+1   
@@ -105,10 +121,10 @@
 !            mmol(iq)=100.
 !          endif
-!        enddo !do iq=1,nqmx
+!        enddo !do iq=1,nq
 !      endif ! of if (dustbin.gt.0)
 
 
 !      if (doubleq) then
-!        do iq=1,nqmx
+!        do iq=1,nq
 !          if (noms(iq).eq."dust_mass") then
 !            igcm_dust_mass=iq
@@ -122,5 +138,5 @@
 !      endif ! of if (doubleq)
       ! 2. find chemistry and water tracers
-      do iq=1,nqmx
+      do iq=1,nq
         if (noms(iq).eq."co2") then
           igcm_co2=iq
@@ -147,10 +163,10 @@
 !          write(*,*) 'h2o_ice: count=',count
         endif
-      enddo ! of do iq=1,nqmx
+      enddo ! of do iq=1,nq
       
       ! check that we identified all tracers:
-      if (count.ne.nqmx) then
+      if (count.ne.nq) then
         write(*,*) "initracer: found only ",count," tracers"
-        write(*,*) "               expected ",nqmx
+        write(*,*) "               expected ",nq
         do iq=1,count
           write(*,*)'      ',iq,' ',trim(noms(iq))
@@ -159,5 +175,5 @@
       else
         write(*,*) "initracer: found all expected tracers, namely:"
-        do iq=1,nqmx
+        do iq=1,nq
           write(*,*)'      ',iq,' ',trim(noms(iq))
         enddo
@@ -168,5 +184,5 @@
 c     Initialisation tracers ....
 c------------------------------------------------------------
-      call zerophys(nqmx,rho_q)
+      call zerophys(nq,rho_q)
 
       rho_dust=2500.  ! Mars dust density (kg.m-3)
@@ -182,6 +198,6 @@
 c$$$c       iq=1: Q mass mixing ratio, iq=2: N number mixing ratio
 c$$$
-c$$$        if( (nqmx.lt.2).or.(water.and.(nqmx.lt.3)) ) then
-c$$$          write(*,*)'initracer: nqmx is too low : nqmx=', nqmx
+c$$$        if( (nq.lt.2).or.(water.and.(nq.lt.3)) ) then
+c$$$          write(*,*)'initracer: nq is too low : nq=', nq
 c$$$          write(*,*)'water= ',water,' doubleq= ',doubleq   
 c$$$        end if
@@ -259,10 +275,15 @@
 
 
-!         if(ngridmx.eq.1)
+!         if(ngrid.eq.1)
 
 
 !     to be modified for BC+ version?
-         do ig=1,ngridmx
-           if (ngridmx.ne.1) watercaptag(ig)=.false.
+
+         !! this is defined in surfdat_h.F90
+         IF (.not.ALLOCATED(dryness)) ALLOCATE(dryness(ngrid))
+         IF (.not.ALLOCATED(watercaptag)) ALLOCATE(watercaptag(ngrid))
+
+         do ig=1,ngrid
+           if (ngrid.ne.1) watercaptag(ig)=.false.
            dryness(ig) = 1.
          enddo
@@ -274,22 +295,22 @@
 c Perennial H20 north cap defined by watercaptag=true (allows surface to be
 c hollowed by sublimation in vdifc).
-!         do ig=1,ngridmx
+!         do ig=1,ngrid
 !           if (lati(ig)*180./pi.gt.84) then
-!             if (ngridmx.ne.1) watercaptag(ig)=.true.
+!             if (ngrid.ne.1) watercaptag(ig)=.true.
 !             dryness(ig) = 1.
 c Use the following cap definition for high spatial resolution (latitudinal bin <= 5 deg)
 c	      if (lati(ig)*180./pi.lt.85.and.long(ig).ge.0) then
-c	        if (ngridmx.ne.1) watercaptag(ig)=.true.
+c	        if (ngrid.ne.1) watercaptag(ig)=.true.
 c               dryness(ig) = 1.
 c	      endif
 c             if (lati(ig)*180./pi.ge.85) then
-c               if (ngridmx.ne.1) watercaptag(ig)=.true.
+c               if (ngrid.ne.1) watercaptag(ig)=.true.
 c               dryness(ig) = 1.
 c	      endif
 !           endif  ! (lati>80 deg)
-!         end do ! (ngridmx)
+!         end do ! (ngrid)
 !        ENDIF ! (caps)
 
-!         if(iceparty.and.(nqmx.ge.2)) then
+!         if(iceparty.and.(nq.ge.2)) then
 
            radius(igcm_h2o_ice)=3.e-6
@@ -303,6 +324,6 @@
 
 
-!         elseif(iceparty.and.(nqmx.lt.2)) then
-!            write(*,*) 'nqmx is too low : nqmx=', nqmx
+!         elseif(iceparty.and.(nq.lt.2)) then
+!            write(*,*) 'nq is too low : nq=', nq
 !            write(*,*) 'water= ',water,' iceparty= ',iceparty
 !         endif
Index: trunk/LMDZ.GENERIC/libf/phystd/iniwrite.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniwrite.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniwrite.F	(revision 787)
@@ -1,3 +1,6 @@
       SUBROUTINE iniwrite(nid,idayref,phis)
+
+      USE comsoil_h
+
       IMPLICIT NONE
 
@@ -31,5 +34,4 @@
 #include "serre.h"
 #include"dimphys.h"
-#include"comsoil.h"
 
 c   Arguments:
Index: trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F	(revision 787)
@@ -3,4 +3,5 @@
       use radinc_h, only: L_NSPECTI
       use radcommon_h, only: WNOI,DWNI
+      use comsoil_h
 
       implicit none
@@ -35,5 +36,4 @@
 #include "serre.h"
 #include"dimphys.h"
-#include"comsoil.h"
 
 c   Arguments:
Index: trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F	(revision 787)
@@ -3,4 +3,5 @@
       use radinc_h, only: L_NSPECTV
       use radcommon_h, only: WNOV,DWNV
+      use comsoil_h
 
       implicit none
@@ -35,5 +36,4 @@
 #include "serre.h"
 #include"dimphys.h"
-#include"comsoil.h"
 
 c   Arguments:
Index: trunk/LMDZ.GENERIC/libf/phystd/iniwritesoil.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniwritesoil.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniwritesoil.F90	(revision 787)
@@ -1,3 +1,5 @@
-subroutine iniwritesoil(nid)
+subroutine iniwritesoil(nid,ngrid)
+
+use comsoil_h
 
 ! initialization routine for 'writediagoil'. Here we create/define
@@ -12,8 +14,8 @@
 #include"comcstfi.h"
 #include"comgeom.h"
-#include"comsoil.h"
 #include"netcdf.inc"
 
 ! Arguments:
+integer,intent(in) :: ngrid
 integer,intent(in) :: nid ! NetCDF output file ID
 
@@ -246,6 +248,7 @@
   do i=1,iip1
     data3(i,1,l)=inertiedat(1,l)
-    data3(i,jjp1,l)=inertiedat(ngridmx,l)
+    data3(i,jjp1,l)=inertiedat(ngrid,l)
   enddo
+  !!! THIS WILL NOT WORK IN PARALLEL !!!!
   ! rest of the grid
   do j=2,jjm
Index: trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90	(revision 787)
@@ -5,4 +5,5 @@
   use watercommon_h, only: mH2O
   use ioipsl_getincom 
+  use comsaison_h
 
   implicit none
@@ -31,7 +32,5 @@
 #include "comcstfi.h"
 #include "planete.h"
-#include "comsaison.h"
 #include "control.h"
-#include "advtrac.h"
 
   ! --------------------------------------------------------------
@@ -71,10 +70,12 @@
   real dTstrat
   real aerosol(nlayermx,naerkind) ! aerosol tau (kg/kg)
-  real OLR_nu(ngridmx,L_NSPECTI)
-  real OSR_nu(ngridmx,L_NSPECTV)
+  real OLR_nu(1,L_NSPECTI)
+  real OSR_nu(1,L_NSPECTV)
   real Eatmtot
 
   integer ierr
   logical firstcall,lastcall,global1d
+
+  character*20 nametrac(nqmx)   ! name of the tracer (no need for adv trac common)
 
   ! --------------
@@ -92,4 +93,9 @@
   nlayer=nlayermx
   nlevel=nlayer+1
+
+  !! this is defined in comsaison_h
+  ALLOCATE(mu0(1))
+  ALLOCATE(fract(1))
+
 
 
@@ -224,5 +230,5 @@
         do iq=1,nq
            ! minimal version, just read in the tracer names, 1 per line
-           read(90,*,iostat=ierr) tnom(iq)
+           read(90,*,iostat=ierr) nametrac(iq)
            if (ierr.ne.0) then
               write(*,*) 'kcm1d: error reading tracer names...'
@@ -232,10 +238,10 @@
      endif
 
-     call initracer()
+     call initracer(1,nq,nametrac)
 
   endif
 
 
-  do iq=1,nqmx
+  do iq=1,nq
      do ilay=1,nlayer
         q(ilay,iq) = 0.
@@ -243,5 +249,5 @@
   enddo
 
-  do iq=1,nqmx
+  do iq=1,nq
      qsurf(iq) = 0.
   enddo
@@ -265,9 +271,9 @@
 
      !    Run radiative transfer
-     call callcorrk(ngridmx,nlayer,q,nqmx,qsurf,      &
+     call callcorrk(1,nlayer,q,nq,qsurf,      &
           albedo,emis,mu0,plev,play,temp,                    &
           tsurf,fract,dist_star,aerosol,muvar,         &
           dtlw,dtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,    &
-          fluxabs_sw,fluxtop_dn,OLR_nu,OSR_nu,reffrad,tau_col,  &
+          fluxabs_sw,fluxtop_dn,OLR_nu,OSR_nu,reffrad,nueffrad,tau_col,  &
           cloudfrac,totcloudfrac,.false.,firstcall,lastcall)
 
@@ -298,10 +304,10 @@
   firstcall=.false.
   lastcall=.true.
-  call callcorrk(ngridmx,nlayer,q,nqmx,qsurf,      &
+  call callcorrk(1,nlayer,q,nq,qsurf,      &
        albedo,emis,mu0,plev,play,temp,                    &
        tsurf,fract,dist_star,aerosol,muvar,         &
        dtlw,dtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,    &
        fluxabs_sw,fluxtop_dn,OLR_nu,OSR_nu,             &
-       reffrad,tau_col,  &
+       reffrad,nueffrad,tau_col,  &
        cloudfrac,totcloudfrac,.false.,firstcall,lastcall)
 
Index: trunk/LMDZ.GENERIC/libf/phystd/largescale.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/largescale.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/largescale.F90	(revision 787)
@@ -1,7 +1,8 @@
-      subroutine largescale(ptimestep, pplev, pplay, pt, pq,   &
+      subroutine largescale(ngrid,nq,ptimestep, pplev, pplay, pt, pq,   &
                         pdt, pdq, pdtlsc, pdqvaplsc, pdqliqlsc, rneb)
 
       use watercommon_h, only : RLVTT, RCPD, RVTMP2,  &
           T_h2O_ice_clouds,T_h2O_ice_liq,Psat_water,Lcpdqsat_water
+      USE tracer_h
       IMPLICIT none
 
@@ -23,22 +24,20 @@
 #include "comcstfi.h"
 
-#include "fisice.h"
 #include "callkeys.h"
-#include "tracer.h"
 
-
+      INTEGER ngrid,nq
 
 !     Arguments
       REAL ptimestep                 ! intervalle du temps (s)
-      REAL pplev(ngridmx,nlayermx+1) ! pression a inter-couche
-      REAL pplay(ngridmx,nlayermx)   ! pression au milieu de couche
-      REAL pt(ngridmx,nlayermx)      ! temperature (K)
-      real pq(ngridmx,nlayermx,nqmx) ! tracer mixing ratio (kg/kg)
-      REAL pdt(ngridmx,nlayermx)     ! physical temperature tenedency (K/s)
-      REAL pdq(ngridmx,nlayermx,nqmx)! physical tracer tenedency (K/s)
-      REAL pdtlsc(ngridmx,nlayermx)  ! incrementation de la temperature (K)
-      REAL pdqvaplsc(ngridmx,nlayermx) ! incrementation de la vapeur d'eau
-      REAL pdqliqlsc(ngridmx,nlayermx) ! incrementation de l'eau liquide
-      REAL rneb(ngridmx,nlayermx)    ! fraction nuageuse
+      REAL pplev(ngrid,nlayermx+1) ! pression a inter-couche
+      REAL pplay(ngrid,nlayermx)   ! pression au milieu de couche
+      REAL pt(ngrid,nlayermx)      ! temperature (K)
+      real pq(ngrid,nlayermx,nq) ! tracer mixing ratio (kg/kg)
+      REAL pdt(ngrid,nlayermx)     ! physical temperature tenedency (K/s)
+      REAL pdq(ngrid,nlayermx,nq)! physical tracer tenedency (K/s)
+      REAL pdtlsc(ngrid,nlayermx)  ! incrementation de la temperature (K)
+      REAL pdqvaplsc(ngrid,nlayermx) ! incrementation de la vapeur d'eau
+      REAL pdqliqlsc(ngrid,nlayermx) ! incrementation de l'eau liquide
+      REAL rneb(ngrid,nlayermx)    ! fraction nuageuse
 
 
@@ -53,29 +52,29 @@
       INTEGER,PARAMETER :: nitermax=1000
       REAL,PARAMETER :: alpha=.5,qthreshold=1.e-6
-      REAL zt(ngridmx), zq(ngridmx)
-      REAL zcond(ngridmx),zcond_iter
-      REAL zdelq(ngridmx)
-      REAL zqs(ngridmx), zdqs(ngridmx)
+      REAL zt(ngrid), zq(ngrid)
+      REAL zcond(ngrid),zcond_iter
+      REAL zdelq(ngrid)
+      REAL zqs(ngrid), zdqs(ngrid)
       REAL psat_tmp
       
 ! evaporation calculations
-      REAL dqevap(ngridmx,nlayermx),dtevap(ngridmx,nlayermx)     
-      REAL qevap(ngridmx,nlayermx,nqmx)
-      REAL tevap(ngridmx,nlayermx)
+      REAL dqevap(ngrid,nlayermx),dtevap(ngrid,nlayermx)     
+      REAL qevap(ngrid,nlayermx,nq)
+      REAL tevap(ngrid,nlayermx)
 
-      REAL zcor(ngridmx), zdelta(ngridmx), zcvm5(ngridmx)
-      REAL zx_q(ngridmx)
+      REAL zcor(ngrid), zdelta(ngrid), zcvm5(ngrid)
+      REAL zx_q(ngrid)
       REAL Nmix_local,zfice
 
 !     GCM -----> subroutine variables, initialisation of outputs
 
-      pdtlsc(1:ngridmx,1:nlayermx)  = 0.0
-      pdqvaplsc(1:ngridmx,1:nlayermx)  = 0.0
-      pdqliqlsc(1:ngridmx,1:nlayermx) = 0.0
-      rneb(1:ngridmx,1:nlayermx) = 0.0
+      pdtlsc(1:ngrid,1:nlayermx)  = 0.0
+      pdqvaplsc(1:ngrid,1:nlayermx)  = 0.0
+      pdqliqlsc(1:ngrid,1:nlayermx) = 0.0
+      rneb(1:ngrid,1:nlayermx) = 0.0
 
 
       ! Evaporate cloud water/ice
-      call evap(ptimestep,pt,pq,pdq,pdt,dqevap,dtevap,qevap,tevap)
+      call evap(ngrid,nq,ptimestep,pt,pq,pdq,pdt,dqevap,dtevap,qevap,tevap)
       ! note: we use qevap but not tevap in largescale/moistadj
             ! otherwise is a big mess
@@ -85,10 +84,10 @@
    DO k = nlayermx, 1, -1
 
-      zt(1:ngridmx)=pt(1:ngridmx,k)+(pdt(1:ngridmx,k)+dtevap(1:ngridmx,k))*ptimestep
-      zq(1:ngridmx)=qevap(1:ngridmx,k,igcm_h2o_vap) !liquid water is included in qevap
+      zt(1:ngrid)=pt(1:ngrid,k)+(pdt(1:ngrid,k)+dtevap(1:ngrid,k))*ptimestep
+      zq(1:ngrid)=qevap(1:ngrid,k,igcm_h2o_vap) !liquid water is included in qevap
 
 !     Calculer la vapeur d'eau saturante et 
 !     determiner la condensation partielle
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
 
          if(zt(i).le.15.) then
@@ -150,7 +149,7 @@
 
 !     Tendances de t et q
-         pdqvaplsc(1:ngridmx,k)  = dqevap(1:ngridmx,k) - zcond(1:ngridmx)
-         pdqliqlsc(1:ngridmx,k) = - pdqvaplsc(1:ngridmx,k)
-         pdtlsc(1:ngridmx,k)  = pdqliqlsc(1:ngridmx,k)*RLVTT/RCPD
+         pdqvaplsc(1:ngrid,k)  = dqevap(1:ngrid,k) - zcond(1:ngrid)
+         pdqliqlsc(1:ngrid,k) = - pdqvaplsc(1:ngrid,k)
+         pdtlsc(1:ngrid,k)  = pdqliqlsc(1:ngrid,k)*RLVTT/RCPD
 
    Enddo ! k= nlayermx, 1, -1
